import{LitElement,css,html$1 as html,PageViewElement,connect,store,SharedStyles,appurl,fixDrawerPosition,fetchResource,archiveInjury,unarchiveInjury,updateTitle,addAllInjuries,$injuriesDefault as injuries,formDataToJson,doneIcon,unarchiveIcon,archiveIcon,editIcon}from"./my-app.js";class MyInjury extends connect(store)(LitElement){static get properties(){return{injury:{type:Object},_editing:{type:Boolean}}}constructor(){super();this.injury={};this._editing=!1}static get styles(){return[SharedStyles,css`
        .injury-header {
          padding: 12px 0;
        }

        .button-container {
          margin: 0 3px 3px 3px;
        }

        .injury-header, .button-container {
          display: flex;
          flex-direction: row;
          justify-content: space-between;
          align-items: center;
        }

        .injury-header-container {
          display: flex;
          align-items: flex-start;
        }

        p {
          text-align: left;
          margin-left: 12px;
          line-height: 1.3em;
        }

        .date {
          font-size: 14px;
          color: #777;
          margin-right: 12px;
          align-self: center;
        }

        input {
          border: none;
          background: none;
          font-size: 20px;
          color: var(--text-color);
          margin-top: 3px;
          margin-left: 12px;
        }

        input:-webkit-autofill,
        input:-webkit-autofill:hover,
        input:-webkit-autofill:focus,
        input:-webkit-autofill:active  {
            -webkit-box-shadow: 0 0 0 30px var(--light-sand-color) inset !important;
        }

        .action-button {
          fill: #777;
          background: none;
          border: none;
          cursor: pointer;
          margin: 0 2px;
          padding: 4px 5px;
        }
      `]}render(){return html`
    <div class="light-background-field">
      <div class="injury-header" @click="${this._toggleDetails}">
        <form id="injuryEdit">
          <input ?disabled="${!this._editing}" id="title-input" type="text" name="title" value="${this.injury.title}" size="12">
        </form>
        <div class="injury-header-container">
          <button form="injuryEdit" id="submit-edit" style="visibility:hidden;" class="action-button"
          @click="${this._editTitle}">${doneIcon}</button>
          <div class="date">${this.injury.date_reg}</div>
        </div>
      </div>
      <div id="injury-details" style="display:none;">
        <p>Informasjon gitt av helsepersonell, behandling etc. ${this.injury.description}</p>
        <!-- TODO Add info from TreatmentPlan -->
        <p>Oppstått: ${this.injury.date_inj}</p>
        <p>Forventet frisk: ${this.injury.date_rec}</p>
        <div class="button-container">
          ${this.injury.archived?html`
            <button class="action-button" @click="${this._unarchiveButtonClicked}">${unarchiveIcon}</button>
          `:html`
            <button class="action-button" @click="${this._archiveButtonClicked}">${archiveIcon}</button>
          `}
          <button class="action-button" @click="${this._editButtonClicked}">${editIcon}</button>
        </div>
      </div>
    </div>
    `}_toggleDetails(){const details=this.shadowRoot.getElementById("injury-details");if(!this._editing){"none"==details.style.display?details.style.display="block":details.style.display="none"}}_archiveButtonClicked(){if(!this._editing){this.dispatchEvent(new CustomEvent("archived",{detail:this.injury}));const url=appurl+"/api/injuries/"+this.injury.id+"/archive",fetchOptions={method:"PUT"};store.dispatch(fetchResource(url,fetchOptions))}}_unarchiveButtonClicked(){if(!this._editing){this.dispatchEvent(new CustomEvent("unarchived",{detail:this.injury}));const url=appurl+"/api/injuries/"+this.injury.id+"/unarchive",fetchOptions={method:"PUT"};store.dispatch(fetchResource(url,fetchOptions))}}_editButtonClicked(){this._editing=!this._editing}_editTitle(event){const formElement=this.shadowRoot.getElementById("injuryEdit"),jsonFormData=formDataToJson(formElement);this.dispatchEvent(new CustomEvent("title-changed",{detail:this.injury}));const url=appurl+"/api/injuries/"+this.injury.id+"/editTitle",fetchOptions={method:"PUT",headers:{"Content-Type":"application/json"},body:jsonFormData};store.dispatch(fetchResource(url,fetchOptions));this._editing=!1;event.preventDefault()}updated(changedProps){if(changedProps.has("_editing")){const input=this.shadowRoot.getElementById("title-input");this._editing?input.style.background="var(--medium-sand-color)":input.style.background="transparent";const submit=this.shadowRoot.getElementById("submit-edit");this._editing?submit.style.visibility="visible":submit.style.visibility="hidden"}}}window.customElements.define("my-injury",MyInjury);store.addReducers({injuries});class MyInjuries extends connect(store)(PageViewElement){static get properties(){return{_drawerOpened:{type:Boolean},_loggedIn:{type:Boolean},_userType:{type:Number},_userID:{type:Number},_injuriesActive:{type:Array},_injuriesArchived:{type:Array},_fetchWasEmpty:{type:Boolean}}}static get styles(){return[SharedStyles,css`
      .page-content-container {
        margin-top: 15px;
      }
      `]}render(){fixDrawerPosition(this);return html`
    <div id="page" class="page-content-container">
      ${this._loggedIn&&1===this._userType?html`
        ${0===this._injuriesActive.length&&0===this._injuriesArchived.length?html`<p>Ingen skader registrert</p>`:html``}
        ${this._injuriesActive.map(i=>html`
          <my-injury .injury="${i}" @archived="${this._archiveInjury}" @title-changed="${this._updateTitle}"></my-injury>
        `)}
        ${0!==this._injuriesArchived.length?html`<p>Arkiverte skader:</p>`:html``}
        ${this._injuriesArchived.map(i=>html`
          <my-injury .injury="${i}" @unarchived="${this._unarchiveInjury}" @title-changed="${this._updateTitle}"></my-injury>
        `)}
      `:html`<p>Du er ikke logget inn, eller har ikke tilgang til denne siden.</p>`}
    </div>
    `}stateChanged(state){this._drawerOpened=state.app.drawerOpened;this._loggedIn=state.session.loggedIn;this._userType=state.session.userType;this._userID=state.session.userID;this._injuriesActive=state.injuries.injuries_active;this._injuriesArchived=state.injuries.injuries_archived}constructor(){super();this._injuriesActive=[];this._injuriesArchived=[];this._fetchWasEmpty=!1}/*
      Three custom event handlers for updating an injury.
      The injury object is sent in event.detail.
    */_archiveInjury(event){store.dispatch(archiveInjury(event.detail))}_unarchiveInjury(event){store.dispatch(unarchiveInjury(event.detail))}_updateTitle(event){store.dispatch(updateTitle(event.detail))}/*
      shouldFetch() is implemented because when logging in as multiple users consecutively in one browser session,
      firstUpdated() only runs once on named pages such as this, resulting in one user being able to see another user's information
      until they refresh the page. So we need to run the fetch code somewhere else.
    */shouldFetch(){const state=store.getState().injuries;return!this._fetchWasEmpty&&this._loggedIn&&0===state.injuries_active.length&&0===state.injuries_archived.length}// Fetch is done in updated() instead of firstUpdated() and wrapped in a shouldFetch() check.
updated(changedProps){if(this.shouldFetch()){const url=appurl+"/api/injuries/"+this._userID,fetchOptions={method:"GET"};store.dispatch(fetchResource(url,fetchOptions)).then(()=>{const data=store.getState().resources.data;if("OK"===data.status){this._injuriesActive=data.injuries_active;this._injuriesArchived=data.injuries_archived;if(0===data.injuries_active.length&&0===data.injuries_archived.length){this._fetchWasEmpty=!0}store.dispatch(addAllInjuries(data.injuries_active,data.injuries_archived))}})}if(changedProps.has("_loggedIn")&&!this._loggedIn){this._fetchWasEmpty=!1;// Reset on logout
}}}window.customElements.define("my-injuries",MyInjuries);