import{css,html$1 as html,PageViewElement,SharedStyles,connect,store,fetchResource,fixDrawerPosition,formDataToJson,appurl,eyeOnIcon,eyeOffIcon}from"./my-app.js";class NewUser extends connect(store)(PageViewElement){static get properties(){return{_drawerOpened:{type:Boolean},_loggedIn:{type:Boolean},eyeIcon:{type:String},passwordInsecureMsg:{type:String},emailExistsMsg:{type:String},invitationCodeWrongMsg:{type:String},socialNumExistsOrInvalidMsg:{type:String}}}constructor(){super();this.eyeIcon=eyeOnIcon}stateChanged(state){this._drawerOpened=state.app.drawerOpened;this._loggedIn=state.session.loggedIn}static get styles(){return[SharedStyles,css`
      .page-content-container {
        margin-top: 10px;
      }

      @media (min-width: 480px) {
        #newUserFirstName, #newUserLastName {
          max-width: 202px;
        }
      }
      `]}render(){fixDrawerPosition(this);return html`
      <div id="page" class="page-content-container">
      ${!this._loggedIn?html`
        <p>Har du allerede en bruker? <a href="/">Logg inn</a></p>
        <form id="regForm" @submit="${this._submitForm}">
          <div class="form-radio">
            <label class="radio-box" for="athlete" title="Jeg er en utøver">Utøver
              <input type="radio" id="athlete" name="user_type" value="1" required>
              <span class="radio-checkmark"></span>
            </label>
            <label class="radio-box" for="team_representative" title="Jeg representerer en klubb/et lag">Klubbrepresentant
              <input type="radio" id="team_representative" name="user_type" value="2" required>
              <span class="radio-checkmark"></span>
            </label>
            <label class="radio-box" for="health_professional" title="Jeg er helsepersonell">Helsepersonell
              <input type="radio" id="health_professional" name="user_type" value="3" required>
              <span class="radio-checkmark"></span>
            </label>
          </div>
          <div class="form-row">
            <div class="form-input">
              <label for="newUserCode">Invitasjonskode</label>
              <input type="text" name="code" id="newUserCode" placeholder="Invitasjonskode" maxlength="80" required>
              <div class="input-notice-container">
                <div class="input-notice">${this.invitationCodeWrongMsg}</div>
              </div>
            </div>
          </div>
          <div class="form-row">
            <div class="form-input">
              <label for="newUserFirstName">Fornavn</label>
              <input type="text" name="first_name" id="newUserFirstName" placeholder="Fornavn" maxlength="50" required>
            </div>
            <div class="form-input">
              <label for="newUserLastName">Etternavn</label>
              <input type="text" name="last_name" id="newUserLastName" placeholder="Etternavn" maxlength="50" required>
            </div>
          </div>
          <div class="form-row">
            <div class="form-input">
              <label for="newUserEmail">Epost</label>
              <input type="email" name="email" id="newUserEmail" placeholder="Epost" maxlength="80" required>
              <div class="input-notice-container">
                <div class="input-notice">${this.emailExistsMsg}</div>
              </div>
            </div>
          </div>
          <div class="form-row">
            <div class="form-input">
              <label for="newUserPhone">Telefonnummer</label>
              <input type="tel" pattern="[1-9]{1}[0-9]{7}" name="phone_num" id="newUserPhone"
              placeholder="Telefonnummer (8 siffer)" required>
            </div>
          </div>
          <div class="form-row">
            <div class="form-input">
              <label for="newUserSocialNum">Personnummer</label>
              <input type="tel" pattern="[0-9]{11}" name="social_num" id="newUserSocialNum"
              placeholder="Personnummer (11 siffer)" required>
              <div class="input-notice-container">
                <div class="input-notice">${this.socialNumExistsOrInvalidMsg}</div>
              </div>
            </div>
          </div>
          <div class="form-row">
            <div class="form-input">
              <label for="newUserPassword">Passord</label>
              <input type="password" name="password" id="newUserPassword" placeholder="Passord"
              title="Passordet må være på minst 10 tegn."
              @input="${this._validatePassword}" required>
              <div class="input-notice-container">
                <div class="input-notice-password">${this.passwordInsecureMsg}</div>
              </div>
              <div class="input-eye-icon" @click="${this._eyeIconClicked}">${this.eyeIcon}</div>
            </div>
          </div>
          <div class="form-comment">
            Passordet må være på minst 10 tegn og må ikke være et vanlig brukt passord.
            Bruk gjerne en setning, det er lett å huske men vanskelig å gjette.
          </div>
          <input class="input-app-button" id="submitButton" type="submit" value="Opprett bruker">
        </form>
        `:html`
        <p>Vennligst logg ut for å registrere en ny bruker.</p>
        `}
      </div>
    `}_submitForm(event){const formElement=this.shadowRoot.getElementById("regForm"),jsonFormData=formDataToJson(formElement),url=appurl+"/api/users",fetchOptions={method:"POST",headers:{"Content-Type":"application/json"},body:jsonFormData};store.dispatch(fetchResource(url,fetchOptions)).then(()=>{const data=store.getState().resources.data;// Reset any input field messages
this.emailExistsMsg="";this.invitationCodeWrongMsg="";this.socialNumExistsOrInvalidMsg="";this.passwordInsecureMsg="";switch(data.status){case"OK":window.location.replace("/");// Redirect to home, prompting login
break;case"EmailExists":this.emailExistsMsg="Eposten er allerede registrert.";break;case"InvitationCodeWrong":this.invitationCodeWrongMsg="Koden finnes ikke eller er feil.";break;case"SocialNumExists":this.socialNumExistsOrInvalidMsg="Personnummeret er allerede registrert.";break;case"DateInvalid":this.socialNumExistsOrInvalidMsg="Ugyldig f\xF8dselsdato (format DDMM\xC5\xC5)";break;case"PasswordInsecure":this.passwordInsecureMsg="Passordet er for svakt.";break;case"ERR":break;default:break;}});event.preventDefault()}_eyeIconClicked(){this.eyeIcon=this.eyeIcon==eyeOnIcon?eyeOffIcon:eyeOnIcon;const input=this.shadowRoot.getElementById("newUserPassword");"password"==input.getAttribute("type")?input.setAttribute("type","text"):input.setAttribute("type","password")}_validatePassword(){const password=this.shadowRoot.getElementById("newUserPassword").value.toLowerCase(),submit=this.shadowRoot.getElementById("submitButton");if(10>password.length){this.passwordInsecureMsg="Passordet m\xE5 v\xE6re p\xE5 minst 10 tegn.";submit.disabled=!0}else{this.passwordInsecureMsg="";submit.disabled=!1}}}window.customElements.define("new-user",NewUser);