import { LitElement, html, css } from 'lit-element';
import { SharedStyles } from './shared-styles.js';
import { connect } from 'pwa-helpers/connect-mixin.js';
import { store } from '../store.js';
import { appurl } from '../helpers/url.js';
import { fetchResource } from '../actions/server-fetch.js';

/*
  Homepage for team representatives. Should render a table of athletes like HealthProfHome.
  A team representative is only connected to one team, so we can render the table directly in here
  without using a subcomponent. See health-prof-table.js.
*/
class TeamRepHome extends connect(store)(LitElement) {
  static get properties() {
    return {
      userID: { type: Number }
    };
  }

  static get styles() {
    return [
      SharedStyles,
      css`
      .page-wide-content-container {
        margin-top: 15px;
      }
      `
    ];
  }

  render() {
    return html`
    <div class="page-wide-content-container">

    </div>
    `
  }

  firstUpdated() {
    // Fetch table information from the database
    // Send fetch request to /api/users/tr/<this.userID>
  }
}

window.customElements.define('team-rep-home', TeamRepHome);
